/*
  Copyright (C) 2021 Arm Limited or its affiliates. All rights reserved.

  SPDX-License-Identifier: Apache-2.0

  Licensed under the Apache License, Version 2.0 (the License); you may
  not use this file except in compliance with the License.
  You may obtain a copy of the License at

  www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an AS IS BASIS, WITHOUT
  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

#include "absl/memory/memory.h"
#include "mlir/Dialect/Quant/QuantOps.h"
#include "mlir/Dialect/Quant/QuantTypes.h"
#include "mlir/Dialect/StandardOps/IR/Ops.h"      // from @llvm-project
#include "mlir/IR/AffineMap.h"                    // from @llvm-project
#include "mlir/IR/Attributes.h"                   // from @llvm-project
#include "mlir/IR/BlockAndValueMapping.h"         // from @llvm-project
#include "mlir/IR/Builders.h"                     // from @llvm-project
#include "mlir/IR/Location.h"                     // from @llvm-project
#include "mlir/IR/MLIRContext.h"                  // from @llvm-project
#include "mlir/IR/Operation.h"                    // from @llvm-project
#include "mlir/IR/PatternMatch.h"                 // from @llvm-project
#include "mlir/Interfaces/InferTypeOpInterface.h" // from @llvm-project
#include "mlir/Pass/Pass.h"                       // from @llvm-project
#include "mlir/Transforms/DialectConversion.h"    // from @llvm-project
#include "mlir/Transforms/GreedyPatternRewriteDriver.h"

#include "src/ir/architecture_config/architecture_config.h"
#include "src/transforms/hlcs_generator/hlcs_generator.h"
#include "src/transforms/passes.h"
#include "src/utils/checkIR.h"
#include "src/utils/ir_utils.h"
#include "src/utils/printIR.h"
#include "src/utils/timing.h"

#include "src/ir/cascade_ir.h"
#include "src/ir/hlcs_ir.h"
#include "src/ir/kernel_ir.h"
#include "src/ir/raw_data_attribute/RawDataAttr.h"
#include "src/ir/schedule_ir.h"

#include "src/transforms/memory_organizer/LiveRange.h"
#include "src/transforms/memory_organizer/LiveRangeGraph.h"
#include "src/transforms/memory_organizer/LivenessAnalysis.h"

using namespace std;
#include <iostream>

#define PASS_NAME "planner-hlcs-generator"
#define DEBUG_TYPE PASS_NAME

#define ENABLE_RELOCATE_COMMAND 1
#define ENABLE_TIMING 0

namespace mlir {

namespace planner {

namespace {

mlir::Operation *Create_u8_TFLConstant(OpBuilder &builder,
                                       std::vector<uint32_t> shape,
                                       llvm::SmallVector<uint8_t, 8> &payload) {
  mlir::Location loc = builder.getUnknownLoc();
  llvm::SmallVector<int64_t, 1> tensor_shape;
  for (auto &n : shape)
    tensor_shape.emplace_back(n);
  Type element_type = builder.getIntegerType(8, false);
  RankedTensorType output_type =
      RankedTensorType::get(ArrayRef<int64_t>(tensor_shape), element_type);
  DenseElementsAttr data =
      DenseElementsAttr::get(output_type, llvm::makeArrayRef<uint8_t>(payload));
  return builder.create<TFL::ConstOp>(loc, output_type, data);
}

// These are rounded to 16 when copied in
void copy_value_compressed_to_payload(mlir::Value ssa,
                                      mlir::SmallVector<uint8_t, 8> &payload) {
  Operation *op_const = ssa.getDefiningOp();
  ASSERT_COND(not(llvm::isa<scheduleir::ConstOp>(op_const)),
              "copy_to_payload::ssa Not generated by Constant");

  auto rd = op_const->getAttrOfType<mlir::RawDataAttr>("value_compressed");

  uint8_t *raw_data = (uint8_t *)rd.getData();
  int64_t len = rd.getSize();
  for (int i = 0; i < len; i++)
    payload.push_back(raw_data[i]);

  // Align each stream to 16
  while (((payload.size() % 16) != 0)) {
    payload.push_back(0);
  }
}

// These are rounded to 16 when copied in
void copy_value_to_payload(mlir::Value ssa,
                           mlir::SmallVector<uint8_t, 8> &payload) {
  Operation *op_const = ssa.getDefiningOp();
  ASSERT_COND(not(llvm::isa<scheduleir::ConstOp>(op_const)),
              "copy_to_payload::ssa Not generated by Constant");

  auto rd = op_const->getAttrOfType<mlir::RawDataAttr>("value");

  uint8_t *raw_data = (uint8_t *)rd.getData();
  int64_t len = rd.getSize();
  for (int i = 0; i < len; i++)
    payload.push_back(raw_data[i]);

  // Align each stream to 16
  while (((payload.size() % 16) != 0)) {
    payload.push_back(0);
  }
}

void sum_scratch(int64_t &scratchTensorSize,
                 set<value_unique_id> &Cascade_values,
                 SmallVector<Value, 1> values, std::string debug_label) {
  for (auto v : values) {
    auto t = v.getType().dyn_cast<SchedTensorType>();
    if (t.get_mem_type() == mt_Scratch) {
      if (Cascade_values.find(t.getUniqueId()) == Cascade_values.end()) {
        int64_t v = array_ref_prod<int64_t>(t.getStorageShape());
        scratchTensorSize += v;
        Cascade_values.insert(t.getUniqueId());
      }
    }
  }
}

struct ConvertSchedulerNpuRegion : public RewritePattern {
  explicit ConvertSchedulerNpuRegion(MLIRContext *context)
      : RewritePattern(scheduleir::NpuRegionOp::getOperationName(), 1,
                       context) {}
  LogicalResult matchAndRewrite(Operation *op,
                                PatternRewriter &rewriter) const override;
};

LogicalResult
ConvertSchedulerNpuRegion::matchAndRewrite(Operation *op,
                                           PatternRewriter &rewriter) const {
  OpBuilder builder(op->getContext());

  mlir::ArchitectureConfig::ArchitectureConfigAttr arch_c =
      AccessArchitectureConfigAttribute_From_NpuRegion(op);

  // Find the maximum amount of memory needed at any TimeStamp
  //     Add Scratch Tensor Information
  int64_t scratchTensorSize = 0;
  {
    Region &schedule_npu_region = op->getRegion(0);
    Block &schedule_npu_region_block = schedule_npu_region.front();
    llvm::iplist<Operation> &schedule_npu_region_operations =
        schedule_npu_region_block.getOperations();
    llvm::SmallVector<uint8_t, 8> payload;

    std::set<value_mem_type> target_value_mem_type_set_intermettent = {
        mt_Scratch, mt_Scratch_fast};
    LiveRangeGraph lrg;
    LivenessAnalysis_Cascades(
        lrg, &schedule_npu_region_block, value_mem_area::ma_Sram,
        target_value_mem_type_set_intermettent, op->getContext(), arch_c);

    std::vector<int64_t> mem_usage;
    llvm::iplist<Operation>::iterator i;
    unsigned end_pos = 0;
    for (i = schedule_npu_region_block.begin();
         i != schedule_npu_region_block.end(); i++) {
      if (not(llvm::isa<cascadeir::CascadeRegionOp>(i)))
        continue;
      unsigned cascade_time =
          i->getAttrOfType<mlir::IntegerAttr>("current_time").getInt();
      end_pos = std::max(end_pos, cascade_time);
    }
    end_pos += 2;

    for (unsigned count = 0; count < end_pos; count++)
      mem_usage.push_back(0);

    std::vector<LiveRange *> ranges_sorted = lrg.get_sorted_ranges();
    for (auto lr : ranges_sorted) {
      bool all_correct_mem_area = true;

      for (auto v : lr->values)
        all_correct_mem_area &=
            (v.getType().dyn_cast<SchedTensorType>().get_mem_area() == ma_Sram);

      unsigned storage_size = lr->storage_size;
      // If a Value contribute at this time add its contribution
      for (unsigned j = lr->start_time; j < lr->end_time; j++)
        mem_usage[j] += storage_size;
    }
    scratchTensorSize =
        *(max_element(std::begin(mem_usage), std::end(mem_usage)));
  }
  // std::cout << GREEN << "Scratch Tensor Size: " << RESET << scratchTensorSize
  // << std::endl;
  IntegerAttr scratch_tensor_size =
      builder.getI64IntegerAttr(scratchTensorSize);
  IntegerAttr scratch_fast_tensor_size = builder.getI64IntegerAttr(0);

  Region &schedule_npu_region = op->getRegion(0);
  Block &schedule_npu_region_block = schedule_npu_region.front();
  llvm::iplist<Operation> &schedule_npu_region_operations =
      schedule_npu_region_block.getOperations();

  START_TIMING;
  // 0.  Mark Weight Tensor on both sides of a DMA as WeightCompressed
  for (auto &op_cascade : schedule_npu_region_operations) {
    if (llvm::isa<cascadeir::CascadeRegionOp>(&op_cascade)) {
      Region &cascade_list_region = op_cascade.getRegion(0);
      Block &cascade_list_block = cascade_list_region.front();
      llvm::iplist<Operation> &cascade_operations =
          cascade_list_block.getOperations();
      for (auto &op_kernel : cascade_operations) {
        if (llvm::isa<kernelir::KernelRegionOp>(&op_kernel)) {
          Region &region_instruction = op_kernel.getRegion(0);
          Block &block_kernel_region = region_instruction.front();
          llvm::iplist<Operation>::iterator i;
          for (i = block_kernel_region.begin(); i != block_kernel_region.end();
               i++) {
            if ((llvm::isa<scheduleir::Conv2DOp>(*i)) ||
                (llvm::isa<scheduleir::DepthwiseConv2DOp>(*i)) ||
                (llvm::isa<scheduleir::FullyConnectedOp>(*i))) {
              i->getOperand(1)
                  .getType()
                  .dyn_cast<mlir::SchedTensorType>()
                  .set_format(vf_WeightCompressed);
              if (llvm::isa<scheduleir::DmaOp>(
                      i->getOperand(1).getDefiningOp()))
                i->getOperand(1)
                    .getDefiningOp()
                    ->getOperand(0)
                    .getType()
                    .dyn_cast<mlir::SchedTensorType>()
                    .set_format(vf_WeightCompressed);
            }
          }
        }
      }
    }
  }
  END_TIMING("MARK WEIGHT TENSORS")

  // 1. Create the Flash Tensor and copy in weights
  mlir::Operation *flash_weight_tensor;
  llvm::SmallVector<uint8_t, 8> payload;
  START_TIMING;
  for (auto &op_cascade : schedule_npu_region_operations) {
    if (llvm::isa<cascadeir::CascadeRegionOp>(&op_cascade)) {
      Region &cascade_list_region = op_cascade.getRegion(0);
      Block &cascade_list_block = cascade_list_region.front();
      llvm::iplist<Operation> &cascade_operations =
          cascade_list_block.getOperations();
      for (auto &op_kernel : cascade_operations) {
        if (llvm::isa<kernelir::KernelRegionOp>(&op_kernel)) {
          SmallVector<Value, 1> biases =
              mlir::kernelir::ExtractKernelBiasValues(
                  &op_kernel); // This returns the Flash Version as it
                               // automatically climbs the SSA branch
          if (!biases.empty()) {
            SchedTensorType b = biases[0].getType().dyn_cast<SchedTensorType>();
            b.set_address(round_up<uint64_t>(payload.size(), 16));
            ASSERT_COND(
                biases.size() != 1,
                "planner_hlcs_generator::Flash Tensor Generation:: More "
                "than 1 Bias Tensor in a Kernel");
            copy_value_compressed_to_payload(biases[0], payload);
          }

          SmallVector<Value, 1> weights =
              mlir::kernelir::ExtractKernelWeightValues(
                  &op_kernel); // This returns the Flash Version as it
                               // automatically climbs the SSA branch
          if (!weights.empty()) {
            SchedTensorType w =
                weights[0].getType().dyn_cast<SchedTensorType>();
            w.set_address(round_up<uint64_t>(payload.size(), 16));
            ASSERT_COND(
                weights.size() != 1,
                "planner_hlcs_generator::Flash Tensor Generation:: More "
                "than 1 Weight Tensor in a Kernel");
            copy_value_compressed_to_payload(weights[0], payload);
          }

          SmallVector<Value, 1> ewise_consts =
              mlir::kernelir::ExtractEwiseKernelConstValues(
                  &op_kernel); // This returns the Flash Version as it
                               // automatically climbs the SSA branch
          if (!ewise_consts.empty()) {
            SchedTensorType e =
                ewise_consts[0].getType().dyn_cast<SchedTensorType>();
            e.set_address(round_up<uint64_t>(payload.size(), 16));
            ASSERT_COND(
                ewise_consts.size() != 1,
                "planner_hlcs_generator::Flash Tensor Generation:: More "
                "than 1 Elementwise Const Tensor in a Kernel");
            copy_value_to_payload(ewise_consts[0], payload);
          }
        }
      }
    }
  }
  END_TIMING("FLASH TENSOR CREATION")

  // 2. Create HLCS_NpuRegionOp (Insert it where the curent Op is) (It has no
  // Block Attributes)
  Type type = builder.getIndexType();
  Block::iterator insertPoint_HLCSNpuRegion(op);
  builder.setInsertionPoint(op);
  auto hlcs_npu_region_op = builder.create<hlcs::NpuRegionOp>(
      op->getLoc(), type, scratch_tensor_size, scratch_fast_tensor_size,
      builder.getI64IntegerAttr(0), builder.getI64IntegerAttr(0));
  Region &hlcs_npu_region_op_region = hlcs_npu_region_op.getRegion();
  Block *hlcs_npu_region_op_block = builder.createBlock(
      &hlcs_npu_region_op_region, hlcs_npu_region_op_region.begin());

  // 2. Insert Flash Tensor
  std::vector<uint32_t> shape;
  shape.push_back(payload.size());
  builder.setInsertionPoint(hlcs_npu_region_op);
  flash_weight_tensor = Create_u8_TFLConstant(builder, shape, payload);

  // 4. Populate hlcs_npu_region_op
  hlcs_generator generator;
  START_TIMING;
  generator.generate(builder, op, hlcs_npu_region_op, arch_c);
  END_TIMING("HLCS GENERATION")
  // std::cout << BLUE << "HLCS Stream Generation Complete" << RESET <<
  // std::endl;

  // 5. Create Re-Locate Information for this particular NPU Region
#if ENABLE_RELOCATE_COMMAND
  START_TIMING;
  SmallVector<mlir::Value> io_tensors;

  int32_t start_input = 0;
  for (auto &cast_in : schedule_npu_region_operations) {
    if (llvm::isa<scheduleir::CastInOp>(&cast_in)) {
      Operation *tensorinfo =
          generator.search_in_tensor_library(cast_in.getResult(0));
      ASSERT_COND(tensorinfo == nullptr,
                  "hlcs_generator::Relocate::TensorInfo for input not found");
      io_tensors.push_back(tensorinfo->getResult(0));

      hlcs_npu_region_op->setAttr(
          "Input_0_Address",
          builder.getI64IntegerAttr(
              tensorinfo->getAttrOfType<mlir::IntegerAttr>("address")
                  .getInt()));
    }
  }
  int32_t end_input = io_tensors.size();

  int32_t start_output = io_tensors.size();
  for (auto &cast_out : schedule_npu_region_operations) {
    if (llvm::isa<scheduleir::CastOutOp>(&cast_out)) {
      Operation *tensorinfo =
          generator.search_in_tensor_library(cast_out.getOperand(0));
      ASSERT_COND(tensorinfo == nullptr,
                  "hlcs_generator::Relocate::TensorInfo for output not found");
      io_tensors.push_back(tensorinfo->getResult(0));

      hlcs_npu_region_op->setAttr(
          "Output_0_Address",
          builder.getI64IntegerAttr(
              tensorinfo->getAttrOfType<mlir::IntegerAttr>("address")
                  .getInt()));
    }
  }
  int32_t end_output = io_tensors.size();

  auto s_input = builder.getI32IntegerAttr(start_input);
  auto e_input = builder.getI32IntegerAttr(end_input);
  ArrayAttr ifm_range = builder.getArrayAttr({s_input, e_input});

  auto s_output = builder.getI32IntegerAttr(start_output);
  auto e_output = builder.getI32IntegerAttr(end_output);
  ArrayAttr ofm_range = builder.getArrayAttr({s_output, e_output});

  auto iterator = hlcs_npu_region_op_block->end();
  iterator--;

  builder.setInsertionPoint(hlcs_npu_region_op_block, iterator);
  auto relocate_op = builder.create<hlcs::RelocateCmd>(op->getLoc(), io_tensors,
                                                       ifm_range, ofm_range);
  END_TIMING("RELOCATE COMMAND GENERATION")
#endif

  // 6. Create HLCS_CallNpuRegionCmd which call the HLCS_NpuRegionOp
  Type output_type =
      op->getResult(0)
          .getType(); // ToDo: Update once we have changed to variadic
  mlir::Value input_value = op->getOperand(0);
  ASSERT_COND(op->getNumOperands() != 1,
              "hlcs::CallNpuRegionCmd only supports a single Input. This is a "
              "limitation in the dialect that needs to be improved !!!");
  ASSERT_COND(op->getNumResults() != 1,
              "hlcs::CallNpuRegionCmd only supports a single Output. This is a "
              "limitation in the dialect that needs to be improved !!!");
  // Replace scheduleir::NpuRegionOp -> HLCS_CallNpuRegionCmd
  rewriter.replaceOpWithNewOp<hlcs::CallNpuRegionCmd>(
      op, output_type, hlcs_npu_region_op.getResult(), input_value,
      flash_weight_tensor->getResult(0));

  return success();
}

void LLVM_ATTRIBUTE_UNUSED populateWithGenerated(
    MLIRContext *context, OwningRewritePatternList *patterns) {}

class HLCSGenerator : public PassWrapper<HLCSGenerator, FunctionPass> {
public:
  explicit HLCSGenerator() {}

  StringRef getArgument() const final {
    // This is the argument used to refer to the pass in
    // the textual format (on the commandline for example).
    return PASS_NAME;
  }
  StringRef getDescription() const final {
    // This is a brief description of the pass.
    return "Generate HLCS Stream from higher levels";
  }

  void runOnFunction() override;
};

void HLCSGenerator::runOnFunction() {
  auto function = getFunction();
  auto *ctx = &getContext();

  if (function.getName() == "main") {
    OwningRewritePatternList patterns(ctx);

    // Add the generated patterns to the list.
    populateWithGenerated(ctx, &patterns);

    patterns.insert<ConvertSchedulerNpuRegion>(ctx);
    applyPatternsAndFoldGreedily(function, std::move(patterns));
  }
}

} // anonymous namespace

std::unique_ptr<OperationPass<FuncOp>> CreatePlannerHLCSGenerator() {
  return absl::make_unique<HLCSGenerator>();
}

static PassRegistration<HLCSGenerator> pass;
} // namespace planner
} // namespace mlir
